#include <string.h>
#include <ctype.h>
#include "../include/emailstr.h"

emailstreambuf::emailstreambuf()
	: strstreambuf() {
	_hdr_read = 0;
	_hdr_field = _hdr_info = NULL;
	_hdr_count = 0;
	_pmsgp = 0;
}
emailstreambuf::emailstreambuf(int _n)
	: strstreambuf(_n) {
	_hdr_read = 0;
	_hdr_field = _hdr_info = NULL;
	_hdr_count = 0;
	_pmsgp = 0;
}
emailstreambuf::emailstreambuf(void* (*a)(long), void (*f)(void*))
	: strstreambuf(a, f) {
	_hdr_read = 0;
	_hdr_field = _hdr_info = NULL;
	_hdr_count = 0;
	_pmsgp = 0;
}
emailstreambuf::emailstreambuf(char* _s, int _n, char* _st)
	: strstreambuf(_s, _n, _st) {
	_hdr_read = 0;
	_hdr_field = _hdr_info = NULL;
	_hdr_count = 0;
	_pmsgp = 0;
}
emailstreambuf::emailstreambuf(signed char* _s, int _n, signed char* _st)
	: strstreambuf(_s, _n, _st) {
	_hdr_read = 0;
	_hdr_field = _hdr_info = NULL;
	_hdr_count = 0;
	_pmsgp = 0;
}
emailstreambuf::emailstreambuf(unsigned char* _s, int _n, unsigned char* _st)
	: strstreambuf(_s, _n, _st) {
	_hdr_read = 0;
	_hdr_field = _hdr_info = NULL;
	_hdr_count = 0;
	_pmsgp = 0;
}
int emailstreambuf::do_read_header() {
	char* rptr;
	char* iptr = NULL;
	char* fptr = NULL;
	int _iplus = 0, _fplus = 0, _pfplus = 0;
	char c;
	enum estream_pos {
		in_hdr = 1,
		in_pfield = 2,
		in_field = 4,
		in_ls = 8
	};
	int _pos = in_hdr | in_pfield | in_ls;

	clear_header();
	rptr = pbase();
	while(rptr < pptr()) {
		c = *(rptr++);
		if(_pos & in_ls) {
			if(c == '\n') {
				_pos &= ~in_hdr;
				_pmsgp = (int)(rptr - pbase());
				_pfplus = (int)(rptr - pbase()) - 1;
				if(_pos & in_field) {
					fptr = new char[_iplus - _fplus + 1];
					_fmemcpy(fptr, pbase() + _fplus, _iplus - _fplus + 1);
					fptr[_iplus - _fplus] = '\0';
					iptr = new char[_pfplus - _iplus];
					_fmemcpy(iptr, pbase() + _iplus, _pfplus - _iplus);
					iptr[_pfplus - _iplus - 1] = '\0';
					_pos &= ~in_field;
					header_field(fptr, iptr);
					delete[] fptr;
					delete[] iptr;
				}
			}
			else {
				_pos &= ~in_ls;
				if(isspace(c))
					_pos &= ~in_pfield;
				else {
					_pos |= in_pfield;
					_pfplus = (int)(rptr - pbase()) - 1;
				}
			}
		}
		else if(_pos & in_pfield) {
			if(isspace(c))
				_pos &= ~in_pfield;
			else if(c == ':') {
				if(_pos & in_field) {
					fptr = new char[_iplus - _fplus + 1];
					_fmemcpy(fptr, pbase() + _fplus, _iplus - _fplus + 1);
					fptr[_iplus - _fplus] = '\0';
					iptr = new char[_pfplus - _iplus];
					_fmemcpy(iptr, pbase() + _iplus, _pfplus - _iplus);
					iptr[_pfplus - _iplus - 1] = '\0';
					_pos &= ~in_field;
					header_field(fptr, iptr);
					delete[] fptr;
					delete[] iptr;
				}
				_fplus = _pfplus;
				_iplus = (int)(rptr - pbase());
				_pos |= in_field;
				_pos &= ~in_pfield;
			}
		}
		if(c == '\n')
			_pos |= in_ls;
		else
			_pos &= ~in_ls;
		if(!(_pos & in_hdr))
			break;
		if(!(_pos & in_pfield || _pos & in_field))
			return 0;
	}
	return 1;
}
int emailstreambuf::do_clear_header() {
	for(int i = 0; i < _hdr_count; i++) {
		if(_hdr_field && _hdr_field[i])
			delete[] _hdr_field[i];
		if(_hdr_info && _hdr_info[i])
			delete[] _hdr_info[i];
	}
	if(_hdr_field)
		delete[] _hdr_field;
	if(_hdr_info)
		delete[] _hdr_info;
	_hdr_read = 0;
	_hdr_field = _hdr_info = NULL;
	_hdr_count = 0;
	_pmsgp = 0;
	return 1;
}
int emailstreambuf::header_field(char* _fn, char* _s) {
	char** thdrf;
	char** thdri;
	int i;

	thdrf = new char*[_hdr_count + 1];
	thdri = new char*[_hdr_count + 1];
	for(i = 0; i < _hdr_count; i++) {
		thdrf[i] = _hdr_field[i];
		thdri[i] = _hdr_info[i];
	}
	if(_fn && _fn[0] != '\0') {
		thdrf[_hdr_count] = new char[_fstrlen(_fn) + 1];
		_fstrcpy(thdrf[_hdr_count], _fn);
	}
	else
		thdrf[_hdr_count] = NULL;
	if(_s && _s[0] != '\0') {
		thdri[_hdr_count] = new char[_fstrlen(_s) + 1];
		_fstrcpy(thdri[_hdr_count], _s);
	}
	else
		thdri[_hdr_count] = NULL;
	if(_hdr_field)
		delete[] _hdr_field;
	if(_hdr_info)
		delete[] _hdr_info;
	_hdr_field = thdrf;
	_hdr_info = thdri;
	_hdr_count++;
	return 1;
}
int emailstreambuf::header_count(const char* _fn) {
	int count = 0;
	if(!read_header())
		return -1;
	for(int i = 0; i < _hdr_count; i++) {
		if(!_fn || (_hdr_field[i] && _fstrnicmp(_hdr_field[i], _fn, _fstrlen(_fn)) == 0))
			count++;
	}
	return count;
}
int emailstreambuf::header_name(char* _s, int _n, int _i, const char* _fn) {
	int index = 0, len;
	if(!read_header())
		return -1;
	for(int i = 0; i < _hdr_count; i++) {
		if(!_fn || (_hdr_field[i] && _fstrnicmp(_hdr_field[i], _fn, _fstrlen(_fn)) == 0)) {
			if(index == _i) {
				len = (_hdr_field[i] ? _fstrlen(_hdr_field[i]) + 1 : 1);
				len = (len > _n ? _n : len);
				_fstrncpy(_s, _hdr_field[i], len);
				_s[len - 1] = '\0';
				return index;
			}
			index++;
		}
	}
	return -1;
}
int emailstreambuf::header_name_len(int _i, const char* _fn) {
	int index = 0;
	if(!read_header())
		return -1;
	for(int i = 0; i < _hdr_count; i++) {
		if(!_fn || (_hdr_field[i] && _fstrnicmp(_hdr_field[i], _fn, _fstrlen(_fn)) == 0)) {
			if(index == _i)
				return (_hdr_field[i] ? _fstrlen(_hdr_field[i]) : 0);
			index++;
		}
	}
	return -1;
}
int emailstreambuf::header_info(char* _s, int _n, int _i, const char* _fn) {
	int index = 0, len;
	if(!read_header())
		return -1;
	for(int i = 0; i < _hdr_count; i++) {
		if(!_fn || (_hdr_field[i] && _fstrnicmp(_hdr_field[i], _fn, _fstrlen(_fn)) == 0)) {
			if(index == _i) {
				len = (_hdr_info[i] ? _fstrlen(_hdr_info[i]) + 1 : 1);
				len = (len > _n ? _n : len);
				_fstrncpy(_s, _hdr_info[i], len);
				_s[len - 1] = '\0';
				return index;
			}
			index++;
		}
	}
	return -1;
}
int emailstreambuf::header_info_len(int _i, const char* _fn) {
	int index = 0;
	if(!read_header())
		return -1;
	for(int i = 0; i < _hdr_count; i++) {
		if(!_fn || (_hdr_field[i] && _fstrnicmp(_hdr_field[i], _fn, _fstrlen(_fn)) == 0)) {
			if(index == _i)
				return (_hdr_info[i] ? _fstrlen(_hdr_info[i]) : 0);
			index++;
		}
	}
	return -1;
}
int emailstreambuf::header(char* _s, int _n) {
	int len;
	if(!read_header())
		return -1;
	len = (_n > header_len() ? header_len() : _n);
	_fstrncpy(_s, pbase(), len);
	_s[len - 1] = '\0';
	return len;
}
int emailstreambuf::message(char* _s, int _n) {
	int len;
	if(!read_header())
		return -1;
	len = (_n > message_len() ? message_len() : _n);
	_fstrncpy(_s, pbase() + _pmsgp, len);
	_s[len - 1] = '\0';
	return len;
}
